/* app 首页方法 */
(function (window) {
	'use strict';

	var func = {
		goHome: function () {
			func.closeLogin();
			api.setFrameGroupIndex({
				name: 'root_pages',
				index: 0,
				scroll: true
			});
			// 重置导航默认状态
			api.execScript({
				name: 'root',
				frameName: 'nav',
				script: 'try{window.$page.reset()}catch(e){}'
			});
			setTimeout(function () {
				// 开启tab
				func.createNav();
			}, 1000);
		},
		goLogin: function () {
			api.openWin({
				name: 'sign',
				url: './modules/sign/view.html',
				bounces: false,
				slidBackEnabled: false,
				animation: {
					type: "push",
				}
			});
		},
		closeLogin: function () {
			api.closeWin({
				name: 'sign'
			});
		},
		backToRoot: function () {
			//延迟回退是等root_pages换页
			setTimeout(function () {
				api.closeToWin({
					name: 'root'
				});
			}, 500);
		},
		removeLaunch: function () {
			api.removeLaunchView({
				animation: {
					type: 'fade',
					duration: 3000
				}
			});
		},

		setVersion: function (val) {
			api.require('talkingData').setGlobalKV({
				key: 'v',
				value: val
			});
		},
		createNav: function () {
			var screenHeight = window.innerHeight;

			var sysType = api.systemType;
			var pdHeight = 0;
			if (sysType == 'ios') {
				var strSV = api.systemVersion;
				var numSV = parseInt(strSV, 10);
				var fullScreen = api.fullScreen;
				var iOS7StatusBarAppearance = api.iOS7StatusBarAppearance;
				if (numSV >= 7 && !fullScreen && iOS7StatusBarAppearance) {
					pdHeight = 20;
				}
			} else if (sysType == 'android') {
				var ver = api.systemVersion;
				ver = parseFloat(ver);
				if (ver >= 4.4) {
					pdHeight = 25;
				}
			}

			api.openFrame({
				name: 'nav',
				url: './modules/nav/view.html',
				bounces: false,
				rect: {
					x: 0,
					y: screenHeight + pdHeight - 75 - api.safeArea.bottom,
					w: 'auto',
					h: 'auto'
				}
			});
		},
		resizeNavTab: function () {
			var screenHeight = window.innerHeight;

			var sysType = api.systemType;
			var pdHeight = 0;
			if (sysType == 'ios') {
				var strSV = api.systemVersion;
				var numSV = parseInt(strSV, 10);
				var fullScreen = api.fullScreen;
				var iOS7StatusBarAppearance = api.iOS7StatusBarAppearance;
				if (numSV >= 7 && !fullScreen && iOS7StatusBarAppearance) {
					pdHeight = 20;
				}
			} else if (sysType == 'android') {
				var ver = api.systemVersion;
				ver = parseFloat(ver);
				if (ver >= 4.4) {
					pdHeight = 25;
				}
			}

			api.setFrameAttr({
				name: 'nav',
				rect: {
					x: 0,
					y: screenHeight + pdHeight - 75 - api.safeArea.bottom,
					w: 'auto',
					h: 'auto'
				}
			});
		},
		createSlide: function (callback) {
			var frames = [];
			// 1 home 主页
			frames.push({
				name: 'home',
				url: './modules/home_select_branch/view.html',
				bounces: false,
				bgColor: '#f2f2f2',
				delay: 600
			});
			// 2 分析
			frames.push({
				name: 'home_select_branch_analysis',
				url: './modules/home_select_branch_analysis/view.html',
				bounces: false,
				bgColor: '#f2f2f2',
				delay: 600
			});

			// 3 对比
			frames.push({
				name: 'home_contrast',
				url: './modules/home_contrast/view.html',
				bounces: false,
				bgColor: '#f2f2f2',
				delay: 600
			});

			// 4 我的
			frames.push({
				name: 'my',
				url: './modules/my/view.html',
				bounces: false,
				bgColor: '#f2f2f2',
				delay: 600
			});
			setTimeout(function () {
				api.openFrameGroup({
					name: 'root_pages',
					background: '#e1e1e1',
					scrollEnabled: true,
					rect: {
						x: 0,
						y: 0,
						W: 'auto',
						h: 'auto'
					},
					delay: 800,
					index: 0,
					preload: 4,
					frames: frames
				}, function (ret, err) {
					var index = ret.index;
					api.sendEvent({
						name: 'nav_index',
						extra: index
					});
					if (index === 0 && frames.length) {
						frames.length = 0;
						callback();
					}
				});
			}, 800);
		},
		//点击消息栏 跳转页面
		openPopWin: function (params) {

			api.setFrameGroupIndex({
				name: 'root_pages',
				index: 0,
				scroll: true
			});
		},
		preambleClose: function (list, times) {
			return times > 5 || list.length > 1;
		},
		goAndroidSlide: function () {
			// 导航欢迎页配置
			var IMGS = [
				'widget://welcome/P1.png',
				'widget://welcome/P2.png',
				'widget://welcome/P3.png',
				'widget://welcome/P4.png',
				'widget://welcome/P5.png'];
			var SLIDE_SEC = 'widget://welcome/point_03.png';
			var SLIDE_UNSEC = 'widget://welcome/point_05.png';
			var SLIDE_SIZE = 15;
			var SLIDE_MARGIN = 20;
			var welcome = api.require('welcomePage');
			var option = {
				isShow: true,
				SelectedImg: SLIDE_SEC,
				NotSelectedImg: SLIDE_UNSEC,
				ImgSize: SLIDE_SIZE,
				ImgSpacing: SLIDE_MARGIN
			};

			welcome && welcome.openWelcomePage({
				isFullscreen: true,
				AnimationType: 'Default',
				imgs: IMGS,
				setting: option
			}, function (ret, err) {
				console.log(ret);
			});
		},
		goSlide: function () {
			var slider_dot_w = window.screen.width;
			var slider_dot_h = window.screen.height;
			slider_dot_w = parseInt(slider_dot_w / 5, 10);
			slider_dot_h = slider_dot_h - parseInt(slider_dot_h * 0.1, 10);
			var frames = [];
			//1-5  为轮换广告页
			for (var i = 0; i < 5; i++) {
				frames.push({
					name: 'slider_' + i,
					url: './modules/slider_page/view.html?index=' + i,
					bounces: false,
					opaque: true,
					bgColor: '#f2f2f2'
				});
			}

			api.openFrameGroup({
				name: 'slider_pages',
				background: '#f2f2f2',
				rect: {
					x: 0,
					y: 0,
					W: 'auto',
					h: 'auto'
				},
				preload: 5,
				index: 0,
				frames: frames
			}, function (ret, err) {
				var index = ret.index;

				if (index === 0) {
					setTimeout(function () {
						api.openFrame({
							name: 'dot_slider',
							url: './modules/slider_dot/view.html',
							bounces: false,
							pageParam: {
								current: index
							},
							rect: {
								x: slider_dot_w * 2,
								y: slider_dot_h,
								w: slider_dot_w,
								h: 10
							}
						});
					}, 50);
				}
				api.execScript({
					name: 'root',
					frameName: 'dot_slider',
					script: 'try{window.$page.changeDot(' + index + ');}catch(e){}'
				});
			});
		},
		//判断轮换广告是否最新版本
		firstLogin: function () {
			var stat = false;
			var v = api.appVersion;
			var vRef = api.getPrefs({
				sync: true,
				key: 'appSlide'
			});

			if (v) {
				v = v.replace(/\./g, '');
				v = parseInt(v, 10);
			}

			if (vRef) {
				vRef = vRef.replace(/\./g, '');
				vRef = parseInt(vRef, 10);
			}

			if (v > vRef) {
				stat = true;
				!api.debug && this.setVersion(v);
			}

			return stat;
		},
	};

	window.func = func;

})(window);
